dnl ----------------- General purpose m4 Macro library ----------------------
dnl
changequote(`{',`}')dnl
dnl
errprint({General purpose Macro Library.
})dnl
define({forget},)dnl
comment({
; General purpose Macro Library, as used in as86 files.
; (c) Franois-Ren "Far" Rideau Dang-Vu Bn 1995
})dnl
dnl
dnl see info file .../doc/info/m4macros.nfo (section * macro.m4::)
dnl
dnl
dnl --- Constants ---
dnl
define({__nl__},{
})dnl
dnl
dnl
dnl --- Argument mangling ---
dnl
define({nargs},{$#})dnl
define({cat},
	{ifelse($#, 0,,
		$#, 1,{$1},
		{format({%s%s},{$1},cat(shift($@)))})})dnl
define({reverse}, {ifelse($#, 0, , $#, 1, {{$1}},
     			  {reverse(shift($@)), {$1}})})dnl
define({expand},
	$*)dnl
define({quote},
	{{{$*}}})dnl
define({head},
	{$1})dnl
define({tail},
	{shift($@)})dnl
define({accumulate},{accumulate_({$1},$1({$2}))})dnl
define({accumulate_},
	{ifelse({$2},,,{$3},,{$2},
		{{$2},accumulate({$1},{$3})})})dnl
define({defdef},{ifndef({$1},{define({$1},{$2})})})dnl
dnl
dnl
dnl --- Character access ---
dnl
define({split_char},{regexp({$1},{\(.\)\(.*\)},{{\1},{\2}})})dnl
define({char_list},{accumulate({split_char},{$1})})dnl
define({reversechars},{cat(reverse(char_list($1)))})dnl
define({upcase},  {translit({$*},{a-z},{A-Z})})dnl
define({downcase},{translit({$*},{A-Z},{a-z})})dnl
dnl
dnl
dnl --- Loops ---
dnl
define({forloop},
	{pushdef({$1}, {$2})_forloop({$1}, {$2}, {$3}, {$4})popdef({$1})})dnl
define({_forloop},
	{$4{}ifelse($1, {$3}, ,
		{define({$1}, incr($1))_forloop({$1}, {$2}, {$3}, {$4})})})dnl
define({rept},
	{ifelse(eval({$1>0}),1,
		{forloop({i},{1},{$1},{$2})})})dnl
define({irp},
	{cat(pushdef({$1}),
	     pushdef({_loop_body_$1},{shift(shift($@))}),
	     _irp({$1}, $2),
	     popdef({_loop_body_$1}),
	     popdef({$1}))})dnl
define({_irp},
	{ifelse($#, 1,,
		$#, 2,{_irp_once({$1},{$2})},
		{_irp_once({$1},{$2}){}_irp({$1},shift(shift($@)))})})dnl
define({_irp_once},
	{define({$1},{$2})expand(_loop_body_$1){}})dnl
dnl
dnl
dnl --- Counters ---
dnl
define({addvar},
	{define({$1},eval($2+$1))})dnl
define({incrvar},
	{define({$1},incr($1))})dnl
define({varadd},
	{cat($1,addvar({$1},{$2}))})dnl
define({varincr},
	{cat($1,incrvar({$1}))})dnl
dnl
dnl
dnl --- min, max ---
dnl
define({max},{ifelse(eval(($1)>($2)),1,$1,$2)})dnl
define({min},{ifelse(eval(($1)<($2)),1,$1,$2)})dnl
dnl
dnl
dnl --- local labels ---
dnl
define({labelprefix},{L})dnl
define({currentlabel},{0})dnl
define({newlabel},{format({%s%04X},labelprefix,varincr({currentlabel}))})dnl
define({local},
	{cat({pushdef({$1},newlabel)},{expand(shift($@))},{popdef({$1})})})dnl
define({locals},
	{ifelse($#,0,,
		$#,1,{$1},
		{local({$1},locals(shift($@)))})})dnl
dnl
dnl
dnl --- metastacks ---
dnl
define({__newstk__},
    {define({__sp__$1},0)})dnl
define({__push__},
    {incrvar({__sp__$1})define({__stk__$1__}__sp__$1,{$2})})dnl
define({__pop__},
    {addvar({__sp__$1},-1)})dnl
define({__pick__},
    {indir({__stk__$1__}eval(__sp__$1-ifelse({$2},,0,{$2})))})dnl
dnl
dnl
dnl --- diverting ---
dnl
define({__currentdiversion__},0)dnl
define({indiversion},
{pushdef({__currentdiversion__},{$1})dnl
divert({$1})dnl
expand(shift($@))dnl
popdef({__currentdiversion__})dnl
divert(__currentdiversion__)dnl
})dnl
